"""
Loading and storing of animations (uses a texturebox)
"""

import texturebox

class AnimationBox:

	def __init__(self,tBox):
		self.animations = {}
		self.tBox = tBox

	def getFrameName(self,name,frameNumber):
		""" Calculate framename based on animation name and frame number. Format: animationnameXXXX"""
		return name + str(frameNumber).zfill(4)

	def getNumberOfFrames(self,name): 
		return self.animations[name]

	def getFrameTexture(self,name,frameNumber):
		return self.tBox.get(self.getFrameName(name,frameNumber))

	def load(self, name, frames):
		self.animations[name] = frames
		for i in range(frames):
			self.tBox.load(self.getFrameName(name,i+1))

