"""
Loading and storing textures
"""

import os
import pygame
from OpenGL.GL import *


class TextureBox:

	def __init__(self):
		self.textures = {}


	def load(self,name):

		filename = os.path.join('textures',name) + '.png'	
# Cut'n paste from codebook
		textureSurface = pygame.image.load(filename)
 
		textureData = pygame.image.tostring(textureSurface, "RGBA", 1)
 
		width = textureSurface.get_width()
		height = textureSurface.get_height()
 
		texture = glGenTextures(1)
		glBindTexture(GL_TEXTURE_2D, texture)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, textureData)
# End of cut'n paste 

		self.textures[name] = texture

	def get(self,name):
		return self.textures[name]
