from OpenGL.GL import * 

class Tile:
	walkable = False
	def __init__(self, tileset):
		self.topTex = tileset.get("top")
		self.wallTex = tileset.get("wall")
		self.floorTex = tileset.get("floor")

	def renderFloor(self,pos):
		glBindTexture(GL_TEXTURE_2D,self.floorTex)
		glBegin(GL_QUADS)
		glTexCoord2f(0,0); glVertex3f(pos[0],pos[1],0)
		glTexCoord2f(1,0); glVertex3f(pos[0],pos[1]+1,0)
		glTexCoord2f(1,1); glVertex3f(pos[0]+1,pos[1]+1,0)
		glTexCoord2f(0,1); glVertex3f(pos[0]+1,pos[1],0)
		glEnd()

		pass

	def renderTop(self,pos):
		glBindTexture(GL_TEXTURE_2D,self.topTex)
		glBegin(GL_QUADS)
		glTexCoord2f(0,0); glVertex3f(pos[0],pos[1],-2)
		glTexCoord2f(1,0); glVertex3f(pos[0],pos[1]+1,-2)
		glTexCoord2f(1,1); glVertex3f(pos[0]+1,pos[1]+1,-2)
		glTexCoord2f(0,1); glVertex3f(pos[0]+1,pos[1],-2)
		glEnd()
	
	def renderLeftWall(self,pos):
		glBindTexture(GL_TEXTURE_2D,self.wallTex)
		glBegin(GL_QUADS)
		glTexCoord2f(0,0); glVertex3f(pos[0]+1,pos[1],0)
		glTexCoord2f(1,0); glVertex3f(pos[0],pos[1],0)
		glTexCoord2f(1,1); glVertex3f(pos[0],pos[1],-2)
		glTexCoord2f(0,1); glVertex3f(pos[0]+1,pos[1],-2)
		glEnd()
	

	def renderRightWall(self,pos):
		glBindTexture(GL_TEXTURE_2D,self.wallTex)
		glBegin(GL_QUADS)
		glTexCoord2f(0,0); glVertex3f(pos[0]+1,pos[1],0)
		glTexCoord2f(1,0); glVertex3f(pos[0]+1,pos[1]+1,0)
		glTexCoord2f(1,1); glVertex3f(pos[0]+1,pos[1]+1,-2)
		glTexCoord2f(0,1); glVertex3f(pos[0]+1,pos[1],-2)
		glEnd()
	

	def isFloor(self):
		return False

	def renderBack(self,pos):
		pass

	def renderFront(self,pos):
		pass


class backWall(Tile):
	def __init__(self,tileset):
		Tile.__init__(self,tileset)

	def renderBack(self,pos):
		self.renderTop(pos)
		self.renderRightWall(pos)
		self.renderLeftWall(pos)


class leftFrontWall(Tile):
	def __init__(self,tileset):
		Tile.__init__(self,tileset)

	def renderFront(self,pos):
		self.renderTop(pos)
		self.renderLeftWall(pos)

class rightFrontWall(Tile):
	def __init__(self,tileset):
		Tile.__init__(self,tileset)

	def renderFront(self,pos):
		self.renderTop(pos)
		self.renderRightWall(pos)

class bothFrontWall(Tile):
	def __init__(self,tileset):
		Tile.__init__(self,tileset)

	def renderFront(self,pos):
		self.renderTop(pos)
		self.renderRightWall(pos)
		self.renderLeftWall(pos)

class onlyTop(Tile):
	def __init__(self,tileset):
		Tile.__init__(self,tileset)

	def renderFront(self,pos):
		self.renderTop(pos)

class floor(Tile):
	walkable = True
	def __init__(self,tileset):
		Tile.__init__(self,tileset)

	def isFloor(self):
		return True
	
	def renderBack(self,pos):
		self.renderFloor(pos)


class special(Tile):
	walkable = True
	def __init__(self,texture):
		self.floorTex = texture
	
	def renderBack(self,pos):
		#glColor3d(1,0,0)
		self.renderFloor(pos)
		#glColor3d(1,1,1)

	def isFloor(self):
		return True
		

class elevator(Tile):
	def __init__(self,tex,tileset):
		Tile.__init__(self,tileset)
		self.wallTex = tex

	def renderBack(self,pos):
		self.renderLeftWall(pos)
		self.renderRightWall(pos)
		self.renderTop(pos)

		


